package tda548;

import java.math.BigInteger;

public class Rational {

    private int n;
    private int d;   // alltid d > 0

    public int gcd(int a, int b) {
        if (b == 0) { return a; }
        return gcd(b, a % b);
    }

    public Rational(int n, int d) {
        if (d < 1) {
            n = -n;
            d = -d;
        } else if (d == 0) {
            d = d / d; // intentionally divide by zero
        }
        int g = 1;
        if (n > 0) { g = gcd(n,d); }
        if (n < 0) { g = gcd(-n,d); }
        this.n = n / g;
        this.d = d / g;
    }

    public Rational add(Rational r) {
        int n1 = this.n * r.d + r.n * this.d;
        int d1 = this.d * r.d;
        return new Rational(n1,d1);
    }

    public Rational sub(Rational r) {
        int n1 = this.n * r.d - r.n * this.d;
        int d1 = this.d * r.d;
        return new Rational(n1,d1);
    }

    public Rational multiply(Rational r) {
        int n1 = this.n * r.n;
        int d1 = this.d * r.d;
        return new Rational(n1,d1);
    }

    public String toString() {
        return n + "/" + d;
    }

    public String floorIntegerAsString() {
        return String.valueOf(n / d);
    }

}
